;*************************************************************************
;				Constant definitions
;-------------------------------------------------------------------------
.equ	xtal		= 11059200		;11.0592MHz
.equ	boottime	= byte3( xtal / 5 )	;0.2s

.equ	Key_Enter	= 0x0A		;Command end
.equ	Key_LineFeed	= 0x0D		;also command end

.equ	Key_Done        = 'a'		;Command execution successful
.equ	Key_Failed      = 'f'		;Command failed or not avaiable
.equ	Key_Continue	= 'c'		;read or write next byte

;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.def	SaveSreg	= r2		;for interrupt usage
.def	rx_ptr		= r3		;rx data pointer
.def	savesreg	= r4		;save sreg during crc
.def	pbyte		= r5		;byte to program
.def	st1l		= r6		;auto baud timeout counter
.def	st1h		= r7
.def	b4		= r8		;only used from abaud
.def	b5		= r9		;="=
.def	crc_lo		= r10		;crc
.def	crc_hi		= r11
.def	poly_lo		= r12		;crc polynom
.def	poly_hi		= r13
;-------------------------------------------------------------------------
.def	ia0		= r16		;interrupt working registers

.def	flags		= r17
.equ	f_enable	= 0
.equ	f_error		= 1
.equ	f_eeprom	= 2
.equ	f_write		= 3
.equ	f_fast		= 4
.equ	f_verify	= 5

.def	a0		= r18		;working registers
.def	a1		= r19
.def	a2		= r20
.def	a3		= r21
.def	timeout		= r22		;boot start time counter
.def	addrxh		= r23		;M128 extension
.def	addrl		= r24
.def	addrh		= r25
;-------------------------------------------------------------------------
;				Using SRAM
;-------------------------------------------------------------------------
.dseg
	.org		RAMSTART
sram1:
	.org		(sram1 + 0xFF) & 0xFF00		;buffer alignment
.equ	Rx_Size		= 256
Rx_Buff:	.byte	Rx_Size
Rx_Buff_End:
page_buff:	.byte	pagesize * 2
page_buff_end:
.cseg
;-------------------------------------------------------------------------
;				Port definitions
;-------------------------------------------------------------------------
.equ	led_out		= PORTB		;LEDs
.equ	led_ddr		= DDRB
.equ	led0		= PORTB0
.equ	led1		= PORTB1
.equ	led2		= PORTB2
.equ	led5		= PORTB5

.equ	UART_IN		= PIND
.equ	RXD		= PORTD0
;-------------------------------------------------------------------------
