;*************************************************************************
;									 *
;*				ATMEGA Bootloader			 *
;*									 *
;*************************************************************************
.nolist
.include"m8def.inc"
.include"bootload.h"
.list
;
.equ	signature	= 0x1E9307	;Mega8
;
;	sbi	led_ddr, led5		;test program
;	rjmp	pc

.equ	base	= THIRDBOOTSTART
;.equ	base	= 0
	.org	base
	rjmp	init
	.org	base + OVF1addr
	rjmp	OVF1int
	.org	base + URXCaddr
	rjmp	URXCint
	.org	base + NOINTaddr	;end of interrupt vector table
init:
.include"init.inc"
;
;------------------------------------------------------------------------
;	sbi	LED_DDR, LED0		;test output

	rcall	abaud			;detect baud rate
	rcall	set_baud		;set baud rate

;	sbi	LED_DDR, LED1		;test output

main:	cbr	flags, 1<<f_error^1<<f_fast^1<<f_verify^1<<f_write
	rcall	rx_command		;Command received ?
	brcc	main
	rcall	exec_command		;Command execute
	ldi	a0, key_failed		;execution failed
	sbrs	flags, f_error		;test
	ldi	a0, key_done		;execution successful
	sbrc	flags, f_enable
	rcall	putchar			;send command execution status
	rjmp	main
;-------------------------------------------------------------------------
.include"uart.inc"
.include"commexec.inc"
.include"asc2hex.inc"
.include"commands.inc"
.include"hexout.inc"
.include"readcrc.inc"
.include"readsig.inc"
.include"readsize.inc"
.include"version.inc"
.include"read.inc"
.include"program.inc"
.include"userprog.inc"
.include"abaud.inc"
;-------------------------------------------------------------------------
